GNU bug report logs - #39075
28.0.50; Emacs hangs on 100% CPU and grows beyond bounds in shell-mode

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Pieter van Oostrum <pieter@HIDDEN>; merged with #38549; Done: Eli Zaretskii <eliz@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 20 Jan 2020 00:29:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 19 19:29:40 2020
Received: from localhost ([127.0.0.1]:44167 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1itKwl-0000h0-Ko
	for submit <at> debbugs.gnu.org; Sun, 19 Jan 2020 19:29:40 -0500
Received: from smarthost-a.hosting2go.nl ([83.137.198.201]:36776)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pieter-l@HIDDEN>) id 1itKwj-0000gm-KV
 for 39075 <at> debbugs.gnu.org; Sun, 19 Jan 2020 19:29:38 -0500
X-ASG-Debug-ID: 1579480171-0ac37b52055e5980001-ZIxEMc
Received: from server24.hosting2go.nl (server24.hosting2go.nl [83.137.194.11])
 by smarthost-a.hosting2go.nl with ESMTP id TgMvAxUf2vvPXRyM (version=TLSv1.2
 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NO) for
 <39075 <at> debbugs.gnu.org>; Mon, 20 Jan 2020 01:29:31 +0100 (CET)
X-Barracuda-Envelope-From: pieter-l@HIDDEN
X-Barracuda-Effective-Source-IP: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Apparent-Source-IP: 83.137.194.11
Received: (qmail 23977 invoked from network); 20 Jan 2020 00:29:31 -0000
Received: from static-145.132.212.31.ip.telfort.nl (HELO
 cochabamba.vanoostrum.org) (145.132.212.31)
 by server24.hosting2go.nl with SMTP; 20 Jan 2020 00:29:31 -0000
Received-SPF: unknown (server24.hosting2go.nl: domain at 83.137.194.9 does not
 designate permitted sender hosts)
Received: from cochabamba.vanoostrum.org (localhost [IPv6:::1])
 by cochabamba.vanoostrum.org (Postfix) with ESMTP id D25F6A74C019;
 Mon, 20 Jan 2020 01:29:30 +0100 (CET)
From: Pieter van Oostrum <pieter-l@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
 <877e1tz9vb.fsf@HIDDEN> <lxzheoilag.fsf@HIDDEN>
 <lxblr3i4vy.fsf@HIDDEN> <83ftgd13zb.fsf@HIDDEN>
 <4nd0bfb9p0.fsf@HIDDEN>
X-ASG-Orig-Subj: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
Date: Mon, 20 Jan 2020 01:29:28 +0100
In-Reply-To: <4nd0bfb9p0.fsf@HIDDEN> (Glenn Morris's message of
 "Sun, 19 Jan 2020 13:08:43 -0500")
Message-ID: <lximl76kd3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.60 (darwin)
MIME-Version: 1.0
Content-Type: text/plain
X-Barracuda-Connect: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Start-Time: 1579480171
X-Barracuda-Encrypted: ECDHE-RSA-AES256-GCM-SHA384
X-Barracuda-URL: https://83.137.198.201:443/cgi-mod/mark.cgi
X-Virus-Scanned: by bsmtpd at hosting2go.nl
X-Barracuda-Scan-Msg-Size: 1767
X-Barracuda-BRTS-Status: 1
X-Barracuda-Spam-Score: 1.04
X-Barracuda-Spam-Status: No, SCORE=1.04 using global scores of TAG_LEVEL=1000.0
 QUARANTINE_LEVEL=1000.0 KILL_LEVEL=4.5 tests=BSF_SC0_MISMATCH_TO,
 FS_LARGE_PERCENT2
A-X-Hosting2GO-Smarthost: Clean
X-Barracuda-Spam-Report: Code version 3.2, rules version 3.2.3.79449
 Rule breakdown below
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.04 FS_LARGE_PERCENT2      Larger than 100% in subj.
 0.00 BSF_SC0_MISMATCH_TO    Envelope rcpt doesn't match header
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 39075
Cc: Eli Zaretskii <eliz@HIDDEN>, 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Glenn Morris <rgm@HIDDEN> writes:

> This causes a test failure for me on CentOS 8.1.
> (BTW, the bug# in the commit log has a typo, but obviosuly nothing can
> be done about that.)
>
>
> Test shell-tests-completion-before-semi backtrace:
>   signal(ert-test-failed (((should (equal (shell--parse-pcomplete-argu
>   ert-fail(((should (equal (shell--parse-pcomplete-arguments) '(("cd" 
>   #f(compiled-function () #<bytecode 0x45cfa9>)()
>   ert--run-test-internal(#s(ert--test-execution-info :test #s(ert-test
>   ert-run-test(#s(ert-test :name shell-tests-completion-before-semi :d
>   ert-run-or-rerun-test(#s(ert--stats :selector (not (or (tag :expensi
>   ert-run-tests((not (or (tag :expensive-test) (tag :unstable))) #f(co
>   ert-run-tests-batch((not (or (tag :expensive-test) (tag :unstable)))
>   ert-run-tests-batch-and-exit((not (or (tag :expensive-test) (tag :un
>   eval((ert-run-tests-batch-and-exit '(not (or (tag :expensive-test) (
>   command-line-1(("-L" ":." "-l" "ert" "-l" "lisp/shell-tests" "--eval
>   command-line()
>   normal-top-level()
> Test shell-tests-completion-before-semi condition:
>     (ert-test-failed
>      ((should
>        (equal
> 	(shell--parse-pcomplete-arguments)
> 	'...))
>       :form
>       (equal
>        (("cd" "ba" "")
> 	1 4 7)
>        (("cd" "ba" "")
> 	1 4))
>       :value nil :explanation
>       (proper-lists-of-different-length 4 3
> 					(("cd" "ba" "")
> 					 1 4 7)
> 					(("cd" "ba" "")
> 					 1 4)
> 					first-mismatch-at 3)))
>    FAILED  1/2  shell-tests-completion-before-semi (0.000774 sec)

Aahh! My bad. It should have been 1 4 7. I made a copying error.
-- 
Pieter van Oostrum
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 19 Jan 2020 21:41:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 19 16:41:31 2020
Received: from localhost ([127.0.0.1]:43983 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1itIK3-0004yH-0e
	for submit <at> debbugs.gnu.org; Sun, 19 Jan 2020 16:41:31 -0500
Received: from smarthost-b.hosting2go.nl ([83.137.198.202]:47492)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pieter-l@HIDDEN>) id 1itIK2-0004y4-1c
 for 39075 <at> debbugs.gnu.org; Sun, 19 Jan 2020 16:41:30 -0500
X-ASG-Debug-ID: 1579470084-0a9db43b8a1b4ad00001-ZIxEMc
Received: from server24.hosting2go.nl (server24.hosting2go.nl [83.137.194.11])
 by smarthost-b.hosting2go.nl with ESMTP id lusGeSpUjZ0tHNTd (version=TLSv1.2
 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NO) for
 <39075 <at> debbugs.gnu.org>; Sun, 19 Jan 2020 22:41:24 +0100 (CET)
X-Barracuda-Envelope-From: pieter-l@HIDDEN
X-Barracuda-Effective-Source-IP: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Apparent-Source-IP: 83.137.194.11
Received: (qmail 29802 invoked from network); 19 Jan 2020 21:41:23 -0000
Received: from static-145.132.212.31.ip.telfort.nl (HELO
 cochabamba.vanoostrum.org) (145.132.212.31)
 by server24.hosting2go.nl with SMTP; 19 Jan 2020 21:41:23 -0000
Received-SPF: unknown (server24.hosting2go.nl: domain at 83.137.194.9 does not
 designate permitted sender hosts)
Received: from cochabamba.vanoostrum.org (localhost [IPv6:::1])
 by cochabamba.vanoostrum.org (Postfix) with ESMTP id 37790A74AFCE;
 Sun, 19 Jan 2020 22:41:23 +0100 (CET)
From: Pieter van Oostrum <pieter-l@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
 <lxpnfiz6xc.fsf@HIDDEN>
 <vq8sm3b9jq.fsf@HIDDEN>
X-ASG-Orig-Subj: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
Date: Sun, 19 Jan 2020 22:41:22 +0100
In-Reply-To: <vq8sm3b9jq.fsf@HIDDEN> (Glenn Morris's message of
 "Sun, 19 Jan 2020 13:11:53 -0500")
Message-ID: <lxh80rcef1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.60 (darwin)
MIME-Version: 1.0
Content-Type: text/plain
X-Barracuda-Connect: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Start-Time: 1579470084
X-Barracuda-Encrypted: ECDHE-RSA-AES256-GCM-SHA384
X-Barracuda-URL: https://83.137.198.202:443/cgi-mod/mark.cgi
X-Virus-Scanned: by bsmtpd at hosting2go.nl
X-Barracuda-Scan-Msg-Size: 641
X-Barracuda-BRTS-Status: 1
X-Barracuda-Spam-Score: 1.04
X-Barracuda-Spam-Status: No, SCORE=1.04 using global scores of TAG_LEVEL=1000.0
 QUARANTINE_LEVEL=1000.0 KILL_LEVEL=4.5 tests=BSF_SC0_MISMATCH_TO,
 FS_LARGE_PERCENT2
B-X-Hosting2GO-Smarthost: Clean
X-Barracuda-Spam-Report: Code version 3.2, rules version 3.2.3.79446
 Rule breakdown below
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.04 FS_LARGE_PERCENT2      Larger than 100% in subj.
 0.00 BSF_SC0_MISMATCH_TO    Envelope rcpt doesn't match header
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 39075
Cc: 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Glenn Morris <rgm@HIDDEN> writes:

> Pieter van Oostrum wrote:
>
>> I propose to amend the test also, so that it would have caught this
>> error (by hanging).
>
> I haven't read anything else, so take this with a grain of salt, but
> tests that hang (rather than just fail) are a PITA for automated testing.

That is true, but the test is there to test the fix, which makes it no longer hang. And as these are in the same commit, the test should never hang, unless somebody breaks the fix later. But then hanging could occur with any bug.
-- 
Pieter van Oostrum
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 19 Jan 2020 18:12:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 19 13:12:03 2020
Received: from localhost ([127.0.0.1]:43853 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1itF3L-0004Dl-Io
	for submit <at> debbugs.gnu.org; Sun, 19 Jan 2020 13:12:03 -0500
Received: from eggs.gnu.org ([209.51.188.92]:49160)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rgm@HIDDEN>) id 1itF3J-0004DH-Hv
 for 39075 <at> debbugs.gnu.org; Sun, 19 Jan 2020 13:12:02 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38330)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <rgm@HIDDEN>)
 id 1itF3E-0000xN-Bk; Sun, 19 Jan 2020 13:11:56 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.82)
 (envelope-from <rgm@HIDDEN>)
 id 1itF3B-0003iP-DN; Sun, 19 Jan 2020 13:11:53 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Pieter van Oostrum <pieter-l@HIDDEN>
Subject: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
 <lxpnfiz6xc.fsf@HIDDEN>
X-Spook: argus assassinate Hazardous Lockdown Cops Burst SEAL Team
X-Ran: EPjt<C[g]Y[h|tBy1_[_E[+B.9DheE.@U@3B00x7G@R3tSzf!ZQ!SvZ2i07HdeFh2kZ1!\
X-Hue: brightwhite
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Sun, 19 Jan 2020 13:11:53 -0500
In-Reply-To: <lxpnfiz6xc.fsf@HIDDEN> (Pieter van Oostrum's
 message of "Fri, 17 Jan 2020 11:57:51 +0100")
Message-ID: <vq8sm3b9jq.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 39075
Cc: Eli Zaretskii <eliz@HIDDEN>, 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Pieter van Oostrum wrote:

> I propose to amend the test also, so that it would have caught this
> error (by hanging).

I haven't read anything else, so take this with a grain of salt, but
tests that hang (rather than just fail) are a PITA for automated testing.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 19 Jan 2020 18:08:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 19 13:08:53 2020
Received: from localhost ([127.0.0.1]:43848 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1itF0G-00048q-Qu
	for submit <at> debbugs.gnu.org; Sun, 19 Jan 2020 13:08:53 -0500
Received: from eggs.gnu.org ([209.51.188.92]:48945)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rgm@HIDDEN>) id 1itF0E-00048c-8y
 for 39075 <at> debbugs.gnu.org; Sun, 19 Jan 2020 13:08:51 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38309)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <rgm@HIDDEN>)
 id 1itF08-00082T-QY; Sun, 19 Jan 2020 13:08:44 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.82)
 (envelope-from <rgm@HIDDEN>)
 id 1itF07-0003QR-Bx; Sun, 19 Jan 2020 13:08:43 -0500
From: Glenn Morris <rgm@HIDDEN>
To: 39075 <at> debbugs.gnu.org
Subject: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
 <877e1tz9vb.fsf@HIDDEN> <lxzheoilag.fsf@HIDDEN>
 <lxblr3i4vy.fsf@HIDDEN> <83ftgd13zb.fsf@HIDDEN>
X-Spook: computer terrorism Power lines Sarin Agent radar United
X-Ran: }a,QdgafqeT<zszPC/5(pQj47YUwqQ/qw19p7zXKA\{h6-l@&kvROn-v*R[8*"JWXGClx3
X-Hue: blue
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Sun, 19 Jan 2020 13:08:43 -0500
In-Reply-To: <83ftgd13zb.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 18 Jan
 2020 11:57:44 +0200")
Message-ID: <4nd0bfb9p0.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 39075
Cc: eliz@HIDDEN, pieter@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


This causes a test failure for me on CentOS 8.1.
(BTW, the bug# in the commit log has a typo, but obviosuly nothing can
be done about that.)


Test shell-tests-completion-before-semi backtrace:
  signal(ert-test-failed (((should (equal (shell--parse-pcomplete-argu
  ert-fail(((should (equal (shell--parse-pcomplete-arguments) '(("cd" 
  #f(compiled-function () #<bytecode 0x45cfa9>)()
  ert--run-test-internal(#s(ert--test-execution-info :test #s(ert-test
  ert-run-test(#s(ert-test :name shell-tests-completion-before-semi :d
  ert-run-or-rerun-test(#s(ert--stats :selector (not (or (tag :expensi
  ert-run-tests((not (or (tag :expensive-test) (tag :unstable))) #f(co
  ert-run-tests-batch((not (or (tag :expensive-test) (tag :unstable)))
  ert-run-tests-batch-and-exit((not (or (tag :expensive-test) (tag :un
  eval((ert-run-tests-batch-and-exit '(not (or (tag :expensive-test) (
  command-line-1(("-L" ":." "-l" "ert" "-l" "lisp/shell-tests" "--eval
  command-line()
  normal-top-level()
Test shell-tests-completion-before-semi condition:
    (ert-test-failed
     ((should
       (equal
	(shell--parse-pcomplete-arguments)
	'...))
      :form
      (equal
       (("cd" "ba" "")
	1 4 7)
       (("cd" "ba" "")
	1 4))
      :value nil :explanation
      (proper-lists-of-different-length 4 3
					(("cd" "ba" "")
					 1 4 7)
					(("cd" "ba" "")
					 1 4)
					first-mismatch-at 3)))
   FAILED  1/2  shell-tests-completion-before-semi (0.000774 sec)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075-done <at> debbugs.gnu.org:


Received: (at 39075-done) by debbugs.gnu.org; 18 Jan 2020 09:57:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 04:57:51 2020
Received: from localhost ([127.0.0.1]:40505 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iskrX-0001ym-0U
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 04:57:51 -0500
Received: from eggs.gnu.org ([209.51.188.92]:36225)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iskrV-0001ya-53
 for 39075-done <at> debbugs.gnu.org; Sat, 18 Jan 2020 04:57:49 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49934)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iskrP-0005gu-8h; Sat, 18 Jan 2020 04:57:43 -0500
Received: from [176.228.60.248] (port=4312 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iskrO-0007vB-ME; Sat, 18 Jan 2020 04:57:43 -0500
Date: Sat, 18 Jan 2020 11:57:44 +0200
Message-Id: <83ftgd13zb.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Pieter van Oostrum <pieter-l@HIDDEN>
In-reply-to: <lxblr3i4vy.fsf@HIDDEN> (message from Pieter
 van Oostrum on Thu, 16 Jan 2020 20:21:37 +0100)
Subject: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
 <877e1tz9vb.fsf@HIDDEN> <lxzheoilag.fsf@HIDDEN>
 <lxblr3i4vy.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 39075-done
Cc: mwd@HIDDEN, 39075-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Pieter van Oostrum <pieter-l@HIDDEN>
> Date: Thu, 16 Jan 2020 20:21:37 +0100
> Cc: 39075 <at> debbugs.gnu.org
> 
> Pieter van Oostrum <pieter-l@HIDDEN> writes:
> 
> > Michael Welsh Duggan <mwd@HIDDEN> writes:
> >
> >> This seems very similar to the bug I reported at bug#38549.  Could you
> >> see if this also fixes that recipe and, if so, merge the bugs?
> >>
> > Yes, the same fix solves that bug also. It is the same bug.
> 
> I propose to amend the test also, so that it would have caught this error (by hanging). I add both patches here now. I have tested that all other things worked the same and found no problems.

Thanks, pushed to the release branch.

> Is there an official procedure for requesting the change, or is posting it here sufficient?

It is sufficient to post here, but:

 . please in the future provide a ChangeLog-style commit log message
   (see CONTRIBUTE for more about this);
 . it looks like the disclaimer of your employer has expired several
   years ago, so if you want to continue contributing to Emacs, I
   suggest to start/renew your legal paperwork.




Notification sent to Michael Welsh Duggan <mwd@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Eli Zaretskii <eliz@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 39075-done <at> debbugs.gnu.org:


Received: (at 39075-done) by debbugs.gnu.org; 18 Jan 2020 09:57:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 04:57:51 2020
Received: from localhost ([127.0.0.1]:40505 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iskrX-0001ym-0U
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 04:57:51 -0500
Received: from eggs.gnu.org ([209.51.188.92]:36225)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iskrV-0001ya-53
 for 39075-done <at> debbugs.gnu.org; Sat, 18 Jan 2020 04:57:49 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49934)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iskrP-0005gu-8h; Sat, 18 Jan 2020 04:57:43 -0500
Received: from [176.228.60.248] (port=4312 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iskrO-0007vB-ME; Sat, 18 Jan 2020 04:57:43 -0500
Date: Sat, 18 Jan 2020 11:57:44 +0200
Message-Id: <83ftgd13zb.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Pieter van Oostrum <pieter-l@HIDDEN>
In-reply-to: <lxblr3i4vy.fsf@HIDDEN> (message from Pieter
 van Oostrum on Thu, 16 Jan 2020 20:21:37 +0100)
Subject: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
 <877e1tz9vb.fsf@HIDDEN> <lxzheoilag.fsf@HIDDEN>
 <lxblr3i4vy.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 39075-done
Cc: mwd@HIDDEN, 39075-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Pieter van Oostrum <pieter-l@HIDDEN>
> Date: Thu, 16 Jan 2020 20:21:37 +0100
> Cc: 39075 <at> debbugs.gnu.org
> 
> Pieter van Oostrum <pieter-l@HIDDEN> writes:
> 
> > Michael Welsh Duggan <mwd@HIDDEN> writes:
> >
> >> This seems very similar to the bug I reported at bug#38549.  Could you
> >> see if this also fixes that recipe and, if so, merge the bugs?
> >>
> > Yes, the same fix solves that bug also. It is the same bug.
> 
> I propose to amend the test also, so that it would have caught this error (by hanging). I add both patches here now. I have tested that all other things worked the same and found no problems.

Thanks, pushed to the release branch.

> Is there an official procedure for requesting the change, or is posting it here sufficient?

It is sufficient to post here, but:

 . please in the future provide a ChangeLog-style commit log message
   (see CONTRIBUTE for more about this);
 . it looks like the disclaimer of your employer has expired several
   years ago, so if you want to continue contributing to Emacs, I
   suggest to start/renew your legal paperwork.




Notification sent to Pieter van Oostrum <pieter@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Eli Zaretskii <eliz@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 17 Jan 2020 10:58:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 17 05:58:04 2020
Received: from localhost ([127.0.0.1]:38892 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isPKF-0004oV-L3
	for submit <at> debbugs.gnu.org; Fri, 17 Jan 2020 05:58:03 -0500
Received: from smarthost-b.hosting2go.nl ([83.137.198.202]:59995)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pieter-l@HIDDEN>) id 1isPKB-0004nu-BH
 for 39075 <at> debbugs.gnu.org; Fri, 17 Jan 2020 05:58:02 -0500
X-ASG-Debug-ID: 1579258673-0a9db43b881a8c270001-ZIxEMc
Received: from server24.hosting2go.nl (server24.hosting2go.nl [83.137.194.11])
 by smarthost-b.hosting2go.nl with ESMTP id hJhDH4kSD8Y4xvLi (version=TLSv1.2
 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NO) for
 <39075 <at> debbugs.gnu.org>; Fri, 17 Jan 2020 11:57:53 +0100 (CET)
X-Barracuda-Envelope-From: pieter-l@HIDDEN
X-Barracuda-Effective-Source-IP: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Apparent-Source-IP: 83.137.194.11
Received: (qmail 28273 invoked from network); 17 Jan 2020 10:57:52 -0000
Received: from static-145.132.212.31.ip.telfort.nl (HELO
 cochabamba.vanoostrum.org) (145.132.212.31)
 by server24.hosting2go.nl with SMTP; 17 Jan 2020 10:57:52 -0000
Received-SPF: unknown (server24.hosting2go.nl: domain at 83.137.194.9 does not
 designate permitted sender hosts)
Received: from cochabamba.vanoostrum.org (localhost [IPv6:::1])
 by cochabamba.vanoostrum.org (Postfix) with ESMTP id 5E3BEA6B6DE0;
 Fri, 17 Jan 2020 11:57:52 +0100 (CET)
From: Pieter van Oostrum <pieter-l@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
X-ASG-Orig-Subj: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
Date: Fri, 17 Jan 2020 11:57:51 +0100
In-Reply-To: <lxa76r5uhe.fsf@HIDDEN> (Pieter van Oostrum's
 message of "Mon, 13 Jan 2020 14:58:05 +0100")
Message-ID: <lxpnfiz6xc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.60 (darwin)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Barracuda-Connect: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Start-Time: 1579258673
X-Barracuda-Encrypted: ECDHE-RSA-AES256-GCM-SHA384
X-Barracuda-URL: https://83.137.198.202:443/cgi-mod/mark.cgi
X-Virus-Scanned: by bsmtpd at hosting2go.nl
X-Barracuda-Scan-Msg-Size: 3420
X-Barracuda-BRTS-Status: 1
X-Barracuda-Spam-Score: 1.04
X-Barracuda-Spam-Status: No, SCORE=1.04 using global scores of TAG_LEVEL=1000.0
 QUARANTINE_LEVEL=1000.0 KILL_LEVEL=4.5 tests=BSF_SC0_MISMATCH_TO,
 FS_LARGE_PERCENT2
B-X-Hosting2GO-Smarthost: Clean
X-Barracuda-Spam-Report: Code version 3.2, rules version 3.2.3.79394
 Rule breakdown below
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.04 FS_LARGE_PERCENT2      Larger than 100% in subj.
 0.00 BSF_SC0_MISMATCH_TO    Envelope rcpt doesn't match header
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 39075
Cc: 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Pieter van Oostrum <pieter-l@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>> Thanks, this was very useful.  It turns out to reproduce one must do
>> this at the shell's prompt, after "M-x shell":
>>
>>   $ cd /some/directory/;
>>
>> The /some/directory/ part should be a real directory.  Once one types
>> the semi-colon, Emacs hangs.  Here's the Lisp backtrace:
>>
>>   "Automatic GC" (0x0)
>>   "looking-at" (0x766f5fc8)
>>   "shell--parse-pcomplete-arguments" (0x766f64f8)
>>   "pcomplete-parse-arguments" (0x766f6a90)
>>   "pcomplete-completions" (0x766f6f60)
>>   "pcomplete-completions-at-point" (0x766f7698)
>>   "run-hook-with-args-until-success" (0x766f7690)
>>   "comint-completion-at-point" (0x766f7b10)
>>   0x317f7b0 PVEC_COMPILED
>>   "completion-in-region--postch" (0x766f8450)
>>
>> So I think shell--parse-pcomplete-arguments infloops in this case.
>
> Yes, I have traced it.
>
> shell--parse-pcomplete-arguments splits the line into chunk, each chunk being either
> 1) a sequence of chars not containing white space, \ " ' ;
> 2) a sequence of chars between apostrophes (') not containing ', maybe final one missing
> 3) a sequence of chars between quotes (") not containing unescaped ", maybe final one missing
> 4) a backslash (\) possibly followed by a char
>
> It uses a regexp for that.
> It collects a list of these chunks.
> It skips over white space between the chunks.
>
> The problem is that a semicolon ; is not covered by this regexp. In the case that caused the error the end position was after the semicolon but the match loop stopped just before the semicolon, and would never advance. It kept going in an infinite loop, continually pushing empty strings on the result list, thereby exhausting memory, and using 100% CPU time.
> I don't know why it wouldn't react to C-g, but I guess because after some time it would be mostly in the garbage collector.
>
> Originally case 1) did not have the semicolon.
> It was introduced in commit eaeeece92da51b517097667f13d580aa92ad5d59 on Dec 4, 2018 18:39:47 +0100.
> There was a test case added in test/lisp/shell-tests.el, but it cheated by positioning point before the semicolon.
>
> I think the simplest solution is to add a semicolon to the part where it skips over white space, i.e. treat the semicolon like white space. But I am not wholly sure that the caller doesn't want to see the semicolon. Otherwise the semicolon should be pushed to the result.
>
> diff -u /Users/pieter/TEMP/shell.el.\~1\~ /Users/pieter/TEMP/shell.el
> --- /Users/pieter/TEMP/shell.el.~1~	2020-01-13 14:37:40.000000000 +0100
> +++ /Users/pieter/TEMP/shell.el	2020-01-13 14:38:07.000000000 +0100
> @@ -428,7 +428,7 @@
>      (save-excursion
>        (goto-char begin)
>        (while (< (point) end)
> -	(skip-chars-forward " \t\n")
> +	(skip-chars-forward " \t\n;")
>  	(push (point) begins)
>          (let ((arg ()))
>            (while (looking-at
>
> Diff finished.  Mon Jan 13 14:38:22 2020


I propose to amend the test also, so that it would have caught this
error (by hanging). I add both patches here now. I have tested that all
other things worked the same and found no problems.

Is there an official procedure for requesting the change, or is posting it here sufficient?


--=-=-=
Content-Type: text/plain
Content-Disposition: attachment; filename=shell.patch2
Content-Description: patch

diff --git a/lisp/shell.el b/lisp/shell.el
index 98e830ee49..ecebf937e2 100644
--- a/lisp/shell.el
+++ b/lisp/shell.el
@@ -428,7 +428,7 @@ shell--parse-pcomplete-arguments
     (save-excursion
       (goto-char begin)
       (while (< (point) end)
-	(skip-chars-forward " \t\n")
+	(skip-chars-forward " \t\n;")
 	(push (point) begins)
         (let ((arg ()))
           (while (looking-at
diff --git a/test/lisp/shell-tests.el b/test/lisp/shell-tests.el
index 6d262f8e7c..7113cb941c 100644
--- a/test/lisp/shell-tests.el
+++ b/test/lisp/shell-tests.el
@@ -34,8 +34,7 @@ shell-tests-completion-before-semi
   (with-temp-buffer
     (shell-mode)
     (insert "cd ba;")
-    (forward-char -1)
     (should (equal (shell--parse-pcomplete-arguments)
-                   '(("cd" "ba") 1 4)))))
+                   '(("cd" "ba" "") 1 4)))))
 
 ;;; shell-tests.el ends here

--=-=-=
Content-Type: text/plain


-- 
Pieter van Oostrum
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 16 Jan 2020 19:21:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 16 14:21:52 2020
Received: from localhost ([127.0.0.1]:38366 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isAiG-0005f9-Nc
	for submit <at> debbugs.gnu.org; Thu, 16 Jan 2020 14:21:52 -0500
Received: from smarthost-a.hosting2go.nl ([83.137.198.201]:38717)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pieter-l@HIDDEN>) id 1isAiC-0005ew-SV
 for 39075 <at> debbugs.gnu.org; Thu, 16 Jan 2020 14:21:51 -0500
X-ASG-Debug-ID: 1579202502-0ac37b1e5516221a0001-ZIxEMc
Received: from server24.hosting2go.nl (server24.hosting2go.nl [83.137.194.11])
 by smarthost-a.hosting2go.nl with ESMTP id vZjRdYivLJ6HAS9Q (version=TLSv1.2
 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NO) for
 <39075 <at> debbugs.gnu.org>; Thu, 16 Jan 2020 20:21:42 +0100 (CET)
X-Barracuda-Envelope-From: pieter-l@HIDDEN
X-Barracuda-Effective-Source-IP: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Apparent-Source-IP: 83.137.194.11
Received: (qmail 7039 invoked from network); 16 Jan 2020 19:21:41 -0000
Received: from static-145.132.212.31.ip.telfort.nl (HELO
 cochabamba.vanoostrum.org) (145.132.212.31)
 by server24.hosting2go.nl with SMTP; 16 Jan 2020 19:21:41 -0000
Received-SPF: unknown (server24.hosting2go.nl: domain at 83.137.194.9 does not
 designate permitted sender hosts)
Received: from cochabamba.vanoostrum.org (localhost [IPv6:::1])
 by cochabamba.vanoostrum.org (Postfix) with ESMTP id 9D1D3A6A0BD7;
 Thu, 16 Jan 2020 20:21:38 +0100 (CET)
From: Pieter van Oostrum <pieter-l@HIDDEN>
To: Michael Welsh Duggan <mwd@HIDDEN>
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
 <877e1tz9vb.fsf@HIDDEN> <lxzheoilag.fsf@HIDDEN>
X-ASG-Orig-Subj: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
Date: Thu, 16 Jan 2020 20:21:37 +0100
In-Reply-To: <lxzheoilag.fsf@HIDDEN> (Pieter van Oostrum's
 message of "Wed, 15 Jan 2020 20:15:03 +0100")
Message-ID: <lxblr3i4vy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (darwin)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Barracuda-Connect: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Start-Time: 1579202502
X-Barracuda-Encrypted: ECDHE-RSA-AES256-GCM-SHA384
X-Barracuda-URL: https://83.137.198.201:443/cgi-mod/mark.cgi
X-Virus-Scanned: by bsmtpd at hosting2go.nl
X-Barracuda-Scan-Msg-Size: 699
X-Barracuda-BRTS-Status: 1
X-Barracuda-Spam-Score: 1.04
X-Barracuda-Spam-Status: No, SCORE=1.04 using global scores of TAG_LEVEL=1000.0
 QUARANTINE_LEVEL=1000.0 KILL_LEVEL=4.5 tests=BSF_SC0_MISMATCH_TO,
 FS_LARGE_PERCENT2
A-X-Hosting2GO-Smarthost: Clean
X-Barracuda-Spam-Report: Code version 3.2, rules version 3.2.3.79381
 Rule breakdown below
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.04 FS_LARGE_PERCENT2      Larger than 100% in subj.
 0.00 BSF_SC0_MISMATCH_TO    Envelope rcpt doesn't match header
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 39075
Cc: 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Pieter van Oostrum <pieter-l@HIDDEN> writes:

> Michael Welsh Duggan <mwd@HIDDEN> writes:
>
>> This seems very similar to the bug I reported at bug#38549.  Could you
>> see if this also fixes that recipe and, if so, merge the bugs?
>>
> Yes, the same fix solves that bug also. It is the same bug.

I propose to amend the test also, so that it would have caught this error (by hanging). I add both patches here now. I have tested that all other things worked the same and found no problems.

Is there an official procedure for requesting the change, or is posting it here sufficient?


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=shell.patch

diff --git a/lisp/shell.el b/lisp/shell.el
index 98e830ee49..ecebf937e2 100644
--- a/lisp/shell.el
+++ b/lisp/shell.el
@@ -428,7 +428,7 @@ shell--parse-pcomplete-arguments
     (save-excursion
       (goto-char begin)
       (while (< (point) end)
-	(skip-chars-forward " \t\n")
+	(skip-chars-forward " \t\n;")
 	(push (point) begins)
         (let ((arg ()))
           (while (looking-at
diff --git a/test/lisp/shell-tests.el b/test/lisp/shell-tests.el
index 6d262f8e7c..7113cb941c 100644
--- a/test/lisp/shell-tests.el
+++ b/test/lisp/shell-tests.el
@@ -34,8 +34,7 @@ shell-tests-completion-before-semi
   (with-temp-buffer
     (shell-mode)
     (insert "cd ba;")
-    (forward-char -1)
     (should (equal (shell--parse-pcomplete-arguments)
-                   '(("cd" "ba") 1 4)))))
+                   '(("cd" "ba" "") 1 4)))))
 
 ;;; shell-tests.el ends here

--=-=-=
Content-Type: text/plain


-- 
Pieter van Oostrum
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 15 Jan 2020 19:15:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 15 14:15:19 2020
Received: from localhost ([127.0.0.1]:35561 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iro8J-0005bS-Ky
	for submit <at> debbugs.gnu.org; Wed, 15 Jan 2020 14:15:19 -0500
Received: from smarthost-b.hosting2go.nl ([83.137.198.202]:51170)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pieter-l@HIDDEN>) id 1iro8E-0005b5-8K
 for 39075 <at> debbugs.gnu.org; Wed, 15 Jan 2020 14:15:13 -0500
X-ASG-Debug-ID: 1579115704-0a9db43b8919d7ba0001-ZIxEMc
Received: from server24.hosting2go.nl (server24.hosting2go.nl [83.137.194.11])
 by smarthost-b.hosting2go.nl with ESMTP id jNVDQ8itfUGA27GB (version=TLSv1.2
 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NO) for
 <39075 <at> debbugs.gnu.org>; Wed, 15 Jan 2020 20:15:04 +0100 (CET)
X-Barracuda-Envelope-From: pieter-l@HIDDEN
X-Barracuda-Effective-Source-IP: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Apparent-Source-IP: 83.137.194.11
Received: (qmail 8784 invoked from network); 15 Jan 2020 19:15:03 -0000
Received: from static-145.132.212.31.ip.telfort.nl (HELO
 cochabamba.vanoostrum.org) (145.132.212.31)
 by server24.hosting2go.nl with SMTP; 15 Jan 2020 19:15:03 -0000
Received-SPF: unknown (server24.hosting2go.nl: domain at 83.137.194.9 does not
 designate permitted sender hosts)
Received: from cochabamba.vanoostrum.org (localhost [IPv6:::1])
 by cochabamba.vanoostrum.org (Postfix) with ESMTP id 9ABADA68C019;
 Wed, 15 Jan 2020 20:15:03 +0100 (CET)
From: Pieter van Oostrum <pieter-l@HIDDEN>
To: Michael Welsh Duggan <mwd@HIDDEN>
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
 <877e1tz9vb.fsf@HIDDEN>
X-ASG-Orig-Subj: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
Date: Wed, 15 Jan 2020 20:15:03 +0100
In-Reply-To: <877e1tz9vb.fsf@HIDDEN> (Michael Welsh Duggan's message of
 "Tue, 14 Jan 2020 22:17:28 -0500")
Message-ID: <lxzheoilag.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (darwin)
MIME-Version: 1.0
Content-Type: text/plain
X-Barracuda-Connect: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Start-Time: 1579115704
X-Barracuda-Encrypted: ECDHE-RSA-AES256-GCM-SHA384
X-Barracuda-URL: https://83.137.198.202:443/cgi-mod/mark.cgi
X-Virus-Scanned: by bsmtpd at hosting2go.nl
X-Barracuda-Scan-Msg-Size: 341
X-Barracuda-BRTS-Status: 1
X-Barracuda-Spam-Score: 1.04
X-Barracuda-Spam-Status: No, SCORE=1.04 using global scores of TAG_LEVEL=1000.0
 QUARANTINE_LEVEL=1000.0 KILL_LEVEL=4.5 tests=BSF_SC0_MISMATCH_TO,
 FS_LARGE_PERCENT2
B-X-Hosting2GO-Smarthost: Clean
X-Barracuda-Spam-Report: Code version 3.2, rules version 3.2.3.79361
 Rule breakdown below
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.04 FS_LARGE_PERCENT2      Larger than 100% in subj.
 0.00 BSF_SC0_MISMATCH_TO    Envelope rcpt doesn't match header
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 39075
Cc: 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Michael Welsh Duggan <mwd@HIDDEN> writes:

> This seems very similar to the bug I reported at bug#38549.  Could you
> see if this also fixes that recipe and, if so, merge the bugs?
>
Yes, the same fix solves that bug also. It is the same bug.
-- 
Pieter van Oostrum
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.
Merged 38549 39075. Request was from Pieter van Oostrum <pieter@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 15 Jan 2020 03:17:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 14 22:17:32 2020
Received: from localhost ([127.0.0.1]:34038 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1irZBU-000741-LQ
	for submit <at> debbugs.gnu.org; Tue, 14 Jan 2020 22:17:32 -0500
Received: from md5i.com ([75.151.244.229]:54020)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mwd@HIDDEN>) id 1irZBS-00073p-M6
 for 39075 <at> debbugs.gnu.org; Tue, 14 Jan 2020 22:17:31 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=md5i.com;
 s=dkim; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:References:
 Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=6AQgBAWucxbGzlo/KZyKK5Zr1wVAkfsaEbqicufU7V4=; b=VSsoE1vab1BCa/1lSh9duBEYcM
 aDDQq3x7n0JsskzP+8U1tKMIQbuk3sKX7EaHXwyF6uad6rJDnaKSmDtK7MMEItlV9ubY1Ut5nK+Qo
 YtdkYK6dXHUGk85TX8pTFQOh2;
Received: from md5i by md5i.com with local (Exim 4.93)
 (envelope-from <mwd@HIDDEN>)
 id 1irZBQ-0003rf-H6; Tue, 14 Jan 2020 22:17:28 -0500
From: Michael Welsh Duggan <mwd@HIDDEN>
To: Pieter van Oostrum <pieter-l@HIDDEN>
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN> <lxa76r5uhe.fsf@HIDDEN>
Date: Tue, 14 Jan 2020 22:17:28 -0500
In-Reply-To: <lxa76r5uhe.fsf@HIDDEN> (Pieter van Oostrum's
 message of "Mon, 13 Jan 2020 14:58:05 +0100")
Message-ID: <877e1tz9vb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 39075
Cc: Eli Zaretskii <eliz@HIDDEN>, 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

This seems very similar to the bug I reported at bug#38549.  Could you
see if this also fixes that recipe and, if so, merge the bugs?

-- 
Michael Welsh Duggan
(md5i@HIDDEN)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 13 Jan 2020 13:58:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 13 08:58:15 2020
Received: from localhost ([127.0.0.1]:58756 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ir0ER-0004uh-Fy
	for submit <at> debbugs.gnu.org; Mon, 13 Jan 2020 08:58:15 -0500
Received: from smarthost-b.hosting2go.nl ([83.137.198.202]:39761)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pieter-l@HIDDEN>) id 1ir0EP-0004uS-Kp
 for 39075 <at> debbugs.gnu.org; Mon, 13 Jan 2020 08:58:14 -0500
X-ASG-Debug-ID: 1578923887-0a9db43b8818e7050001-ZIxEMc
Received: from server24.hosting2go.nl (server24.hosting2go.nl [83.137.194.11])
 by smarthost-b.hosting2go.nl with ESMTP id vwcCDpVkGEwOTFw9 (version=TLSv1.2
 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NO) for
 <39075 <at> debbugs.gnu.org>; Mon, 13 Jan 2020 14:58:07 +0100 (CET)
X-Barracuda-Envelope-From: pieter-l@HIDDEN
X-Barracuda-Effective-Source-IP: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Apparent-Source-IP: 83.137.194.11
Received: (qmail 7313 invoked from network); 13 Jan 2020 13:58:06 -0000
Received: from static-145.132.212.31.ip.telfort.nl (HELO
 cochabamba.vanoostrum.org) (145.132.212.31)
 by server24.hosting2go.nl with SMTP; 13 Jan 2020 13:58:06 -0000
Received-SPF: unknown (server24.hosting2go.nl: domain at 83.137.194.9 does not
 designate permitted sender hosts)
Received: from cochabamba.vanoostrum.org (localhost [IPv6:::1])
 by cochabamba.vanoostrum.org (Postfix) with ESMTP id 43AACA61E356;
 Mon, 13 Jan 2020 14:58:06 +0100 (CET)
From: Pieter van Oostrum <pieter-l@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
 <83blr87eq1.fsf@HIDDEN>
X-ASG-Orig-Subj: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
Date: Mon, 13 Jan 2020 14:58:05 +0100
In-Reply-To: <83blr87eq1.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 12 Jan
 2020 19:43:18 +0200")
Message-ID: <lxa76r5uhe.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (darwin)
MIME-Version: 1.0
Content-Type: text/plain
X-Barracuda-Connect: server24.hosting2go.nl[83.137.194.11]
X-Barracuda-Start-Time: 1578923887
X-Barracuda-Encrypted: ECDHE-RSA-AES256-GCM-SHA384
X-Barracuda-URL: https://83.137.198.202:443/cgi-mod/mark.cgi
X-Virus-Scanned: by bsmtpd at hosting2go.nl
X-Barracuda-Scan-Msg-Size: 2981
X-Barracuda-BRTS-Status: 1
X-Barracuda-Spam-Score: 1.04
X-Barracuda-Spam-Status: No, SCORE=1.04 using global scores of TAG_LEVEL=1000.0
 QUARANTINE_LEVEL=1000.0 KILL_LEVEL=4.5 tests=BSF_SC0_MISMATCH_TO,
 FS_LARGE_PERCENT2
B-X-Hosting2GO-Smarthost: Clean
X-Barracuda-Spam-Report: Code version 3.2, rules version 3.2.3.79312
 Rule breakdown below
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.04 FS_LARGE_PERCENT2      Larger than 100% in subj.
 0.00 BSF_SC0_MISMATCH_TO    Envelope rcpt doesn't match header
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 39075
Cc: 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Thanks, this was very useful.  It turns out to reproduce one must do
> this at the shell's prompt, after "M-x shell":
>
>   $ cd /some/directory/;
>
> The /some/directory/ part should be a real directory.  Once one types
> the semi-colon, Emacs hangs.  Here's the Lisp backtrace:
>
>   "Automatic GC" (0x0)
>   "looking-at" (0x766f5fc8)
>   "shell--parse-pcomplete-arguments" (0x766f64f8)
>   "pcomplete-parse-arguments" (0x766f6a90)
>   "pcomplete-completions" (0x766f6f60)
>   "pcomplete-completions-at-point" (0x766f7698)
>   "run-hook-with-args-until-success" (0x766f7690)
>   "comint-completion-at-point" (0x766f7b10)
>   0x317f7b0 PVEC_COMPILED
>   "completion-in-region--postch" (0x766f8450)
>
> So I think shell--parse-pcomplete-arguments infloops in this case.

Yes, I have traced it.

shell--parse-pcomplete-arguments splits the line into chunk, each chunk being either
1) a sequence of chars not containing white space, \ " ' ;
2) a sequence of chars between apostrophes (') not containing ', maybe final one missing
3) a sequence of chars between quotes (") not containing unescaped ", maybe final one missing
4) a backslash (\) possibly followed by a char

It uses a regexp for that.
It collects a list of these chunks.
It skips over white space between the chunks.

The problem is that a semicolon ; is not covered by this regexp. In the case that caused the error the end position was after the semicolon but the match loop stopped just before the semicolon, and would never advance. It kept going in an infinite loop, continually pushing empty strings on the result list, thereby exhausting memory, and using 100% CPU time.
I don't know why it wouldn't react to C-g, but I guess because after some time it would be mostly in the garbage collector.

Originally case 1) did not have the semicolon.
It was introduced in commit eaeeece92da51b517097667f13d580aa92ad5d59 on Dec 4, 2018 18:39:47 +0100.
There was a test case added in test/lisp/shell-tests.el, but it cheated by positioning point before the semicolon.

I think the simplest solution is to add a semicolon to the part where it skips over white space, i.e. treat the semicolon like white space. But I am not wholly sure that the caller doesn't want to see the semicolon. Otherwise the semicolon should be pushed to the result.

diff -u /Users/pieter/TEMP/shell.el.\~1\~ /Users/pieter/TEMP/shell.el
--- /Users/pieter/TEMP/shell.el.~1~	2020-01-13 14:37:40.000000000 +0100
+++ /Users/pieter/TEMP/shell.el	2020-01-13 14:38:07.000000000 +0100
@@ -428,7 +428,7 @@
     (save-excursion
       (goto-char begin)
       (while (< (point) end)
-	(skip-chars-forward " \t\n")
+	(skip-chars-forward " \t\n;")
 	(push (point) begins)
         (let ((arg ()))
           (while (looking-at

Diff finished.  Mon Jan 13 14:38:22 2020

-- 
Pieter van Oostrum
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 12 Jan 2020 17:43:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 12 12:43:21 2020
Received: from localhost ([127.0.0.1]:57892 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iqhGj-0002ug-8n
	for submit <at> debbugs.gnu.org; Sun, 12 Jan 2020 12:43:21 -0500
Received: from eggs.gnu.org ([209.51.188.92]:51669)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iqhGg-0002uS-R1
 for 39075 <at> debbugs.gnu.org; Sun, 12 Jan 2020 12:43:19 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:36788)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iqhGb-000060-9Y; Sun, 12 Jan 2020 12:43:13 -0500
Received: from [176.228.60.248] (port=4967 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iqhGa-0008Vv-LI; Sun, 12 Jan 2020 12:43:13 -0500
Date: Sun, 12 Jan 2020 19:43:18 +0200
Message-Id: <83blr87eq1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Pieter van Oostrum <pieter-l@HIDDEN>
In-reply-to: <lxa76sk3b9.fsf@HIDDEN> (message from Pieter
 van Oostrum on Sun, 12 Jan 2020 18:11:22 +0100)
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN> <lxa76sk3b9.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 39075
Cc: 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Pieter van Oostrum <pieter-l@HIDDEN>
> Cc: 39075 <at> debbugs.gnu.org
> Date: Sun, 12 Jan 2020 18:11:22 +0100
> 
> I ran it under gdb, and interrupted it several times with C-z in gdb. Most of the stack traces were in the garbage collector, suggesting that it is collecting like crazy. This doesn't surprise me, as it is constantly allocating new memory. The rest of this stack trace doesn't have useful information.
> 
> I managed to get a stack trace where it is processing. I haven't analysed these yet, but I include both here.

Thanks, this was very useful.  It turns out to reproduce one must do
this at the shell's prompt, after "M-x shell":

  $ cd /some/directory/;

The /some/directory/ part should be a real directory.  Once one types
the semi-colon, Emacs hangs.  Here's the Lisp backtrace:

  "Automatic GC" (0x0)
  "looking-at" (0x766f5fc8)
  "shell--parse-pcomplete-arguments" (0x766f64f8)
  "pcomplete-parse-arguments" (0x766f6a90)
  "pcomplete-completions" (0x766f6f60)
  "pcomplete-completions-at-point" (0x766f7698)
  "run-hook-with-args-until-success" (0x766f7690)
  "comint-completion-at-point" (0x766f7b10)
  0x317f7b0 PVEC_COMPILED
  "completion-in-region--postch" (0x766f8450)

So I think shell--parse-pcomplete-arguments infloops in this case.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 12 Jan 2020 17:11:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 12 12:11:33 2020
Received: from localhost ([127.0.0.1]:57875 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iqglx-000293-52
	for submit <at> debbugs.gnu.org; Sun, 12 Jan 2020 12:11:33 -0500
Received: from [145.132.212.31] (port=58651 helo=cochabamba.vanoostrum.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pieter-l@HIDDEN>) id 1iqglu-00028o-RP
 for 39075 <at> debbugs.gnu.org; Sun, 12 Jan 2020 12:11:31 -0500
Received: from cochabamba.vanoostrum.org (localhost [IPv6:::1])
 by cochabamba.vanoostrum.org (Postfix) with ESMTP id C0340A60D81D;
 Sun, 12 Jan 2020 18:11:23 +0100 (CET)
From: Pieter van Oostrum <pieter-l@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#39075: 28.0.50; Emacs hangs on 100% CPU and grows beyond
 bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
 <83y2ue71py.fsf@HIDDEN>
Date: Sun, 12 Jan 2020 18:11:22 +0100
In-Reply-To: <83y2ue71py.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 11 Jan
 2020 11:59:37 +0200")
Message-ID: <lxa76sk3b9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (darwin)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: >> Date: Fri, 10 Jan
 2020 22:16:58 +0100 >> From: Pieter van Oostrum <pieter@HIDDEN> >>
 >> 1) Emacs -Q >> 2) M-x shell >> 3) type some command, and use some filename
 completions on the way >> [...] 
 Content analysis details:   (1.3 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: vanoostrum.org]
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.3 RDNS_NONE Delivered to internal network by a host with no rDNS
X-Debbugs-Envelope-To: 39075
Cc: 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

--=-=-=
Content-Type: text/plain

Eli Zaretskii <eliz@HIDDEN> writes:

>> Date: Fri, 10 Jan 2020 22:16:58 +0100
>> From: Pieter van Oostrum <pieter@HIDDEN>
>> 
>> 1) Emacs -Q
>> 2) M-x shell
>> 3) type some command, and use some filename completions on the way
>> (using TAB).
>> 4) Type a semicolon (;)
>> 
>> Now Emacs hangs, the ; does not appear, and it doesn't react to a C-g typed.
>> It uses 100% CPU and memory grows beyond bounds, eventually just making
>> my whole computer unresponsive.
>
> I cannot reproduce this on GNU/Linux, so it's probably macOS-specific.

It's not so clear what could be MacOS-specific.

I ran it under gdb, and interrupted it several times with C-z in gdb. Most of the stack traces were in the garbage collector, suggesting that it is collecting like crazy. This doesn't surprise me, as it is constantly allocating new memory. The rest of this stack trace doesn't have useful information.

I managed to get a stack trace where it is processing. I haven't analysed these yet, but I include both here.


--=-=-=
Content-Type: application/octet-stream
Content-Disposition: attachment; filename=semicolon-emacs-loop
Content-Transfer-Encoding: base64
Content-Description: stack traces
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==
--=-=-=
Content-Type: text/plain


-- 
Pieter van Oostrum
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at 39075 <at> debbugs.gnu.org:


Received: (at 39075) by debbugs.gnu.org; 11 Jan 2020 09:59:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 11 04:59:46 2020
Received: from localhost ([127.0.0.1]:55386 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iqDYY-0006Vu-AG
	for submit <at> debbugs.gnu.org; Sat, 11 Jan 2020 04:59:46 -0500
Received: from eggs.gnu.org ([209.51.188.92]:38235)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iqDYX-0006Vi-Lz
 for 39075 <at> debbugs.gnu.org; Sat, 11 Jan 2020 04:59:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46545)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iqDYP-0008Ad-5D; Sat, 11 Jan 2020 04:59:37 -0500
Received: from [176.228.60.248] (port=4148 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iqDYN-0000L1-Vz; Sat, 11 Jan 2020 04:59:36 -0500
Date: Sat, 11 Jan 2020 11:59:37 +0200
Message-Id: <83y2ue71py.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Pieter van Oostrum <pieter@HIDDEN>
In-reply-to: <24088.59850.194801.667764@HIDDEN> (message
 from Pieter van Oostrum on Fri, 10 Jan 2020 22:16:58 +0100)
Subject: Re: bug#39075: 28.0.50;
 Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
References: <24088.59850.194801.667764@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 39075
Cc: 39075 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 10 Jan 2020 22:16:58 +0100
> From: Pieter van Oostrum <pieter@HIDDEN>
> 
> 1) Emacs -Q
> 2) M-x shell
> 3) type some command, and use some filename completions on the way
> (using TAB).
> 4) Type a semicolon (;)
> 
> Now Emacs hangs, the ; does not appear, and it doesn't react to a C-g typed.
> It uses 100% CPU and memory grows beyond bounds, eventually just making
> my whole computer unresponsive.

I cannot reproduce this on GNU/Linux, so it's probably macOS-specific.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 10 Jan 2020 21:17:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 10 16:17:10 2020
Received: from localhost ([127.0.0.1]:55053 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iq1eY-00052d-J0
	for submit <at> debbugs.gnu.org; Fri, 10 Jan 2020 16:17:10 -0500
Received: from lists.gnu.org ([209.51.188.17]:53420)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pieter@HIDDEN>) id 1iq1eW-00052V-Ob
 for submit <at> debbugs.gnu.org; Fri, 10 Jan 2020 16:17:09 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:40677)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <pieter@HIDDEN>) id 1iq1eV-0002AQ-6L
 for bug-gnu-emacs@HIDDEN; Fri, 10 Jan 2020 16:17:08 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.6 required=5.0 tests=BAYES_50,RDNS_NONE,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <pieter@HIDDEN>) id 1iq1eT-00010q-K2
 for bug-gnu-emacs@HIDDEN; Fri, 10 Jan 2020 16:17:07 -0500
Received: from [145.132.212.31] (port=54644 helo=cochabamba.vanoostrum.org)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <pieter@HIDDEN>) id 1iq1eT-0000gt-6a
 for bug-gnu-emacs@HIDDEN; Fri, 10 Jan 2020 16:17:05 -0500
Received: from cochabamba.vanoostrum.org (localhost [IPv6:::1])
 by cochabamba.vanoostrum.org (Postfix) with ESMTP id 417D5A5E9FC5
 for <bug-gnu-emacs@HIDDEN>; Fri, 10 Jan 2020 22:16:59 +0100 (CET)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
Message-ID: <24088.59850.194801.667764@HIDDEN>
Date: Fri, 10 Jan 2020 22:16:58 +0100
From: Pieter van Oostrum <pieter@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; Emacs hangs on 100% CPU and grows beyond bounds in shell-mode
X-Mailer: VM undefined under 27.0.50 (i686-apple-darwin10.0.0)
X-detected-operating-system: by eggs.gnu.org: Mac OS X  [generic] [fuzzy]
X-Received-From: 145.132.212.31
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)



1) Emacs -Q
2) M-x shell
3) type some command, and use some filename completions on the way
(using TAB).
4) Type a semicolon (;)

Now Emacs hangs, the ; does not appear, and it doesn't react to a C-g typed.
It uses 100% CPU and memory grows beyond bounds, eventually just making
my whole computer unresponsive.

Typing a whole series of C-g's might stop the loop (with the ; appearing
then) or it might crash Emacs:
Fatal error 11: Segmentation fault
Abort trap: 6

This report is typed in a session where the sequence of C-g's did stop
the loop.
The C-g caused this message:
Error in post-command-hook (completion-in-region--postch): (quit)
Although the option Enter debugger on Quit/C-g was set, no backtrace was
generated.

This emacs was compiled from master today, but it also happens in earlier versions.


In GNU Emacs 28.0.50 (build 1, i686-apple-darwin10.0.0, NS appkit-1561.61 Version 10.13.6 (Build 17G10021))
 of 2020-01-10 built on cochabamba.vanoostrum.org
Repository revision: 17cfd708575c351d030f8b05c5921d1867028d79
Repository branch: fix
Windowing system distributor 'Apple', version 10.3.1561
System Description:  Mac OS X 10.13.6

Recent messages:
Quit
No match [2 times]
~ 
Error in post-command-hook (completion-in-region--postch): (quit)
Quit [2 times]
Complete, but not unique
Making completion list...
Complete, but not unique
Error in post-command-hook (completion-in-region--postch): (quit)
Quit
Quit
Configured using:
 'configure --build i686-apple-darwin10.0.0 --without-dbus --with-ns
 build_alias=i686-apple-darwin10.0.0 'CFLAGS=-pipe -march=nocona'
 PKG_CONFIG_PATH=/opt/local/lib/pkgconfig/:/usr/X11R6/pkgconfig/:/usr/local/lib/pkgconfig/:/usr/lib/pkgconfig/'

Configured features:
RSVG GLIB NOTIFY KQUEUE ACL GNUTLS LIBXML2 ZLIB TOOLKIT_SCROLL_BARS XIM
NS MODULES THREADS PDUMPER LCMS2

Important settings:
  value of $LC_CTYPE: UTF-8
  value of $LANG: en_GB.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Shell

Minor modes in effect:
  shell-dirtrack-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny dired dired-loaddefs
format-spec rfc822 mml easymenu mml-sec password-cache epa derived epg
epg-config gnus-util rmail rmail-loaddefs text-property-search time-date
subr-x seq byte-opt gv bytecomp byte-compile cconv mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader cl-loaddefs
cl-lib sendmail rfc2047 rfc2045 ietf-drums mm-util mail-prsvr mail-utils
shell pcomplete comint ansi-color ring tooltip eldoc electric uniquify
ediff-hook vc-hooks lisp-float-type mwheel term/ns-win ns-win
ucs-normalize mule-util term/common-win tool-bar dnd fontset image
regexp-opt fringe tabulated-list replace newcomment text-mode elisp-mode
lisp-mode prog-mode register page tab-bar menu-bar rfn-eshadow isearch
timer select scroll-bar mouse jit-lock font-lock syntax facemenu
font-core term/tty-colors frame minibuffer cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote threads kqueue cocoa ns
lcms2 multi-tty make-network-process emacs)

Memory information:
((conses 16 55230 57689)
 (symbols 48 7130 11)
 (strings 32 18286 5181)
 (string-bytes 1 600859)
 (vectors 16 11939)
 (vector-slots 8 157593 69152)
 (floats 8 19 126)
 (intervals 56 1161 97)
 (buffers 1000 14))

-- 
Pieter van Oostrum <pieter@HIDDEN>
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]


-- 
Pieter van Oostrum <pieter@HIDDEN>
www: http://pieter.vanoostrum.org/
PGP key: [8DAE142BE17999C4]




Acknowledgement sent to Pieter van Oostrum <pieter@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#39075; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 20 Jan 2020 00:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.